signature BALANCE =
sig
    type balance = {id :int, name : string, amount : real}

    val addBalance : string -> int
    val lookupBalance : int -> balance
    val modBalance : balance -> unit
    val deleteBalance : int -> unit
    val listBalances : unit -> balance list
    val listOwnedBalances : unit -> balance list
    val listBalanceUsers : int -> Init.user list

    val validBalanceName : string -> bool
    val balanceNameToId : string -> int option
end
